package org.exoplatform.jcr.launcher;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.jcr.RepositoryService;
import org.exoplatform.services.jcr.core.ManageableRepository;

public class JcrServletListener implements ServletContextListener {

  public void contextInitialized(ServletContextEvent event) {
    ServletContext servletContext = event.getServletContext();
    RootContainer rootContainer = RootContainer.getInstance();
    PortalContainer pcontainer = rootContainer
        .getPortalContainer(servletContext.getServletContextName());
    if (pcontainer == null) {
      pcontainer = rootContainer.createPortalContainer(servletContext);
    }
    PortalContainer servicesManager = PortalContainer.getInstance();

    RepositoryService repositoryService = (RepositoryService) servicesManager
        .getComponentInstanceOfType(RepositoryService.class);

    ManageableRepository repository = null;
    try {
      repository = (ManageableRepository) repositoryService.getRepository();
      if (!repository.isWorkspaceInitialized("ws"))
        repository.initWorkspace("ws", "nt:unstructured");      
    } catch (Exception e) {
      e.printStackTrace();
    } 
  }

  public void contextDestroyed(ServletContextEvent event) {
    RootContainer rootContainer = RootContainer.getInstance();
    PortalContainer pcontainer = rootContainer.getPortalContainer(event
        .getServletContext().getServletContextName());
    if (pcontainer.isStarted())
      pcontainer.stop();
    rootContainer.removePortalContainer(event.getServletContext());
  }
}